#
# based on site.pl -- Site dependent code (mostly defining system params)
#
# by Tony Sanders <sanders@bsdi.com>, July 1993
#
# Slightly modified for webfoot.  <lmjm@doc.ic.ac.uk>
#

#
# Error codes
#
do 'errno.ph';
eval 'sub EINVAL {22;}'		unless defined &EINVAL;

#
# File locking
#
do 'sys/unistd.ph';
eval 'sub SEEK_SET {0;}'	unless defined &SEEK_SET;

do 'sys/file.ph';
eval 'sub LOCK_SH {0x01;}'	unless defined &LOCK_SH;
eval 'sub LOCK_EX {0x02;}'	unless defined &LOCK_EX;
eval 'sub LOCK_NB {0x04;}'	unless defined &LOCK_NB;
eval 'sub LOCK_UN {0x08;}'	unless defined &LOCK_UN;

do 'fcntl.ph';
eval 'sub F_RDLCK {1;}'		unless defined &F_RDLCK;
eval 'sub F_WRLCK {2;}'		unless defined &F_WRLCK;
eval 'sub F_UNLCK {3;}'		unless defined &F_UNLCK;
eval 'sub F_SETLK {8;}'		unless defined &F_SETLK;
eval 'sub F_SETLKW {9;}'	unless defined &F_SETLKW;
# WAS:
# $s_flock = "ssllss";		# struct flock {type, whence, start, len,pid,xx}
# Solaris 2.3 requires and other systems dont mind the extra bit
$s_flock = "ssllll";		# struct flock {type, whence, start, len, sysid, pid}


sub seize {
	local ($FH, $lock) = @_;
	local ($flock, $type) = 0;
	if ($lock & &LOCK_SH) { $type = &F_RDLCK; }
	elsif ($lock & &LOCK_EX) { $type = &F_WRLCK; }
	elsif ($lock & &LOCK_UN) { $type = &F_UNLCK; }
	else { $! = &EINVAL; return undef; }
	$flock = pack($s_flock, $type, &SEEK_SET, 0, 0, 0, 0);
	fcntl($FH, ($lock & &LOCK_NB) ? &F_SETLK : &F_SETLKW, $flock);
}

1;
